# Class: Concurrent::AtomicBoolean

Inherits:
  AtomicBooleanImplementation
  - Object
  - Concurrent::AtomicBoolean
  show all

Defined in:
  lib/concurrent-ruby/concurrent/atomic/atomic_boolean.rb

## Overview

A boolean value that can be updated atomically. Reads and writes to an atomic boolean and thread-safe and guaranteed to succeed. Reads and writes may block briefly but no explicit locking is required.

## Thread-safe Variable Classes

Each of the thread-safe variable classes is designed to solve a different problem. In general:

- Agent: Shared, mutable variable providing independent, uncoordinated, asynchronous change of individual values. Best used when the value will undergo frequent, complex updates. Suitable when the result of an update does not need to be known immediately.
- Atom: Shared, mutable variable providing independent, uncoordinated, synchronous change of individual values. Best used when the value will undergo frequent reads but only occasional, though complex, updates. Suitable when the result of an update must be known immediately.
- AtomicReference: A simple object reference that can be updated atomically. Updates are synchronous but fast. Best used when updates a simple set operations. Not suitable when updates are complex. AtomicBoolean and AtomicFixnum are similar but optimized for the given data type.
- Exchanger: Shared, stateless synchronization point. Used when two or more threads need to exchange data. The threads will pair then block on each other until the exchange is complete.
- MVar: Shared synchronization point. Used when one thread must give a value to another, which must take the value. The threads will block on each other until the exchange is complete.
- ThreadLocalVar: Shared, mutable, isolated variable which holds a different value for each thread which has access. Often used as an instance variable in objects which must maintain different state for different threads.
- TVar: Shared, mutable variables which provide coordinated, synchronous, change of many stated. Used when multiple value must change together, in an all-or-nothing transaction. Performance:

    Testing with ruby 2.1.2
    Testing with Concurrent::MutexAtomicBoolean...
      2.790000   0.000000   2.790000 (  2.791454)
    Testing with Concurrent::CAtomicBoolean...
      0.740000   0.000000   0.740000 (  0.740206)

    Testing with jruby 1.9.3
    Testing with Concurrent::MutexAtomicBoolean...
      5.240000   2.520000   7.760000 (  3.683000)
    Testing with Concurrent::JavaAtomicBoolean...
      3.340000   0.010000   3.350000 (  0.855000)

See Also:

- java.util.concurrent.atomic.AtomicBoolean

## Instance Method Summary collapse

- #false? ⇒ Boolean

  Is the current value `false`.

- #initialize(initial = false) ⇒ undocumented constructor

  Creates a new `AtomicBoolean` with the given initial value.

- #make_false ⇒ Boolean

  Explicitly sets the value to false.

- #make_true ⇒ Boolean

  Explicitly sets the value to true.

- #to_s ⇒ String (also: #inspect)

  Short string representation.

- #true? ⇒ Boolean

  Is the current value `true`.

- #value ⇒ Boolean

  Retrieves the current `Boolean` value.

- #value=(value) ⇒ Boolean

  Explicitly sets the value.

## Constructor Details

### #initialize(initial = false) ⇒ `undocumented`

Creates a new `AtomicBoolean` with the given initial value.

Parameters:

- initial (`Boolean`) (defaults to: `false`) —

  the initial value

    118
    119
    120
    121
    122
    123
    124
    125

    # File 'lib/concurrent-ruby/concurrent/atomic/atomic_boolean.rb', line 118

    class AtomicBoolean < AtomicBooleanImplementation
      # @return [String] Short string representation.
      def to_s
        format '%s value:%s>', super[0..-2], value
      end

      alias_method :inspect, :to_s
    end

## Instance Method Details

### #false? ⇒ `Boolean`

Is the current value `false`

Returns:

- (`Boolean`) —

  true if the current value is `false`, else false

    118
    119
    120
    121
    122
    123
    124
    125

    # File 'lib/concurrent-ruby/concurrent/atomic/atomic_boolean.rb', line 118

    class AtomicBoolean < AtomicBooleanImplementation
      # @return [String] Short string representation.
      def to_s
        format '%s value:%s>', super[0..-2], value
      end

      alias_method :inspect, :to_s
    end

### #make_false ⇒ `Boolean`

Explicitly sets the value to false.

Returns:

- (`Boolean`) —

  true if value has changed, otherwise false

    118
    119
    120
    121
    122
    123
    124
    125

    # File 'lib/concurrent-ruby/concurrent/atomic/atomic_boolean.rb', line 118

    class AtomicBoolean < AtomicBooleanImplementation
      # @return [String] Short string representation.
      def to_s
        format '%s value:%s>', super[0..-2], value
      end

      alias_method :inspect, :to_s
    end

### #make_true ⇒ `Boolean`

Explicitly sets the value to true.

Returns:

- (`Boolean`) —

  true if value has changed, otherwise false

    118
    119
    120
    121
    122
    123
    124
    125

    # File 'lib/concurrent-ruby/concurrent/atomic/atomic_boolean.rb', line 118

    class AtomicBoolean < AtomicBooleanImplementation
      # @return [String] Short string representation.
      def to_s
        format '%s value:%s>', super[0..-2], value
      end

      alias_method :inspect, :to_s
    end

### #to_s ⇒ `String` Also known as: inspect

Returns Short string representation.

Returns:

- (`String`) —

  Short string representation.

    120
    121
    122

    # File 'lib/concurrent-ruby/concurrent/atomic/atomic_boolean.rb', line 120

    def to_s
      format '%s value:%s>', super[0..-2], value
    end

### #true? ⇒ `Boolean`

Is the current value `true`

Returns:

- (`Boolean`) —

  true if the current value is `true`, else false

    118
    119
    120
    121
    122
    123
    124
    125

    # File 'lib/concurrent-ruby/concurrent/atomic/atomic_boolean.rb', line 118

    class AtomicBoolean < AtomicBooleanImplementation
      # @return [String] Short string representation.
      def to_s
        format '%s value:%s>', super[0..-2], value
      end

      alias_method :inspect, :to_s
    end

### #value ⇒ `Boolean`

Retrieves the current `Boolean` value.

Returns:

- (`Boolean`) —

  the current value

    118
    119
    120
    121
    122
    123
    124
    125

    # File 'lib/concurrent-ruby/concurrent/atomic/atomic_boolean.rb', line 118

    class AtomicBoolean < AtomicBooleanImplementation
      # @return [String] Short string representation.
      def to_s
        format '%s value:%s>', super[0..-2], value
      end

      alias_method :inspect, :to_s
    end

### #value=(value) ⇒ `Boolean`

Explicitly sets the value.

Parameters:

- value (`Boolean`) —

  the new value to be set

Returns:

- (`Boolean`) —

  the current value

    118
    119
    120
    121
    122
    123
    124
    125

    # File 'lib/concurrent-ruby/concurrent/atomic/atomic_boolean.rb', line 118

    class AtomicBoolean < AtomicBooleanImplementation
      # @return [String] Short string representation.
      def to_s
        format '%s value:%s>', super[0..-2], value
      end

      alias_method :inspect, :to_s
    end